## START: Set by rpmautospec
## (rpmautospec version 0.8.2)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 11;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

%bcond_without check

# https://github.com/redhatinsights/yggdrasil
%global goipath         github.com/redhatinsights/yggdrasil
Version:                0.4.4
%global tag             v%{version}

%gometa -f

%global common_description %{expand:
yggdrasil is a system daemon that subscribes to topics on an MQTT broker and
routes any data received on the topics to an appropriate child "worker" process,
exchanging data with its worker processes through a D-Bus message broker.}

%global golicenses      LICENSE
%global godocs          CONTRIBUTING.md README.md

Name:           yggdrasil
Release:        %autorelease
Summary:        Remote data transmission and processing client

License:        GPL-3.0-only
URL:            %{gourl}
Source:         %{url}/releases/download/%{tag}/yggdrasil-%{version}.tar.xz
Source1:        yggdrasil.sysusers

BuildRequires:  systemd-rpm-macros
BuildRequires:  meson
BuildRequires:  pkgconfig(dbus-1)
BuildRequires:  pkgconfig(systemd)
BuildRequires:  pkgconfig(bash-completion)
%{?sysusers_requires_compat}

%{?systemd_requires}

%description %{common_description}

%package devel
Summary:        %{name} development files

%description devel
%{common_description}

Contains files needed for yggdrasil worker development.

%package examples
Summary:       %{name} example workers

Requires: %{name} = %{version}-%{release}

%description examples
%{common_description}

Contains example workers for yggdrasil.

%gopkg

%prep
%goprep %{?rhel:-k}

%if %{undefined rhel}
%generate_buildrequires
%go_generate_buildrequires
%endif

%build
%undefine _auto_set_build_flags
export %gomodulesmode
%{?gobuilddir:export GOPATH="%{gobuilddir}:${GOPATH:+${GOPATH}:}%{?gopath}"}
%meson -Dexamples=True "-Dgobuildflags=[%(echo %{expand:%gocompilerflags} | sed -e s/"^"/"'"/ -e s/" "/"', '"/g -e s/"$"/"'"/), '-tags', '"rpm_crashtraceback\ ${BUILDTAGS:-}"', '-a', '-v', '-x']" -Dgoldflags='%{?currentgoldflags} -B 0x%(head -c20 /dev/urandom|od -An -tx1|tr -d " \n") -compressdwarf=false -linkmode=external -extldflags "%{build_ldflags} %{?__golang_extldflags}"'
%meson_build

%global gosupfiles ./ipc/com.redhat.Yggdrasil1.Dispatcher1.xml ./ipc/com.redhat.Yggdrasil1.Worker1.xml
%install
%meson_install
%__install -d -m 0755 %{buildroot}%{_localstatedir}/lib/yggdrasil
%gopkginstall

%if %{with check}
%check
%gocheck
%endif

%pre
%sysusers_create_compat %{SOURCE1}

%post
%systemd_post %{name}.service
%systemd_user_post %{name}.service

%preun
%systemd_preun %{name}.service
%systemd_user_preun %{name}.service

%postun
%systemd_postun_with_restart %{name}.service
%systemd_user_postun_with_restart %{name}.service

%files
%license LICENSE
%if %{defined rhel}
%license vendor/modules.txt
%endif
%doc CONTRIBUTING.md README.md
%{_bindir}/yggd
%{_bindir}/yggctl
%config(noreplace) %{_sysconfdir}/%{name}
%{_unitdir}/yggdrasil-bus@.service
%{_unitdir}/yggdrasil-bus@.socket
%{_unitdir}/yggdrasil@.service
%{_unitdir}/yggdrasil.service
%{_userunitdir}/yggdrasil.service
%{_sysusersdir}/yggdrasil.conf
%{_datadir}/bash-completion/completions/yggd
%{_datadir}/bash-completion/completions/yggctl
%{_datadir}/dbus-1/interfaces/com.redhat.Yggdrasil1.xml
%{_datadir}/dbus-1/interfaces/com.redhat.Yggdrasil1.Worker1.xml
%{_datadir}/dbus-1/interfaces/com.redhat.Yggdrasil1.Dispatcher1.xml
%{_datadir}/dbus-1/system.d/yggd.conf
%{_datadir}/dbus-1/system-services/com.redhat.Yggdrasil1.service
%{_datadir}/doc/%{name}/tags.toml
%{_mandir}/man1/yggctl.1.gz
%{_mandir}/man1/yggd.1.gz
%attr(0755, yggdrasil, yggdrasil) %{_localstatedir}/lib/yggdrasil

%files devel
%{_libdir}/pkgconfig/yggdrasil.pc

%files examples
%{_libexecdir}/yggdrasil/echo
%{_datadir}/dbus-1/system.d/com.redhat.Yggdrasil1.Worker1.echo.conf
%{_datadir}/dbus-1/system-services/com.redhat.Yggdrasil1.Worker1.echo.service
%{_unitdir}/com.redhat.Yggdrasil1.Worker1.echo.service

%gopkgfiles

%changelog
## START: Generated by rpmautospec
* Fri Jul 25 2025 Fedora Release Engineering <releng@fedoraproject.org> - 0.4.4-11
- Rebuilt for https://fedoraproject.org/wiki/Fedora_43_Mass_Rebuild

* Mon Feb 03 2025 Link Dupont <link@sub-pop.net> - 0.4.4-8
- Include example workers in subpackage

* Sun Jan 19 2025 Fedora Release Engineering <releng@fedoraproject.org> - 0.4.4-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_42_Mass_Rebuild

* Thu Nov 07 2024 Link Dupont <link@sub-pop.net> - 0.4.4-6
- Include local state dir

* Mon Sep 23 2024 Link Dupont <link@sub-pop.net> - 0.4.4-5
- Use systemd_sysusers_compat

* Sat Sep 21 2024 Link Dupont <link@sub-pop.net> - 0.4.4-4
- Include the golang-devel subpackage (required by workers)

* Sat Sep 21 2024 Link Dupont <link@sub-pop.net> - 0.4.4-3
- Drop automatic golang package

* Fri Sep 20 2024 Link Dupont <link@sub-pop.net> - 0.4.4-2
- Run systemd-sysusers before installing package

* Sun Sep 15 2024 Packit <hello@packit.dev> - 0.4.4-1
- Update to 0.4.4 upstream release
- Resolves: rhbz#2312400

* Wed Sep 11 2024 Link Dupont <link@sub-pop.net> - 0.4.3-1
- Update to version 0.4.3 (RHBZ#2311702)

* Thu Aug 01 2024 Link Dupont <link@sub-pop.net> - 0.4.2-1
- Update to version 0.4.2 (RHBZ#2302349)

* Sat Jul 20 2024 Fedora Release Engineering <releng@fedoraproject.org> - 0.4.1-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_41_Mass_Rebuild

* Sun Feb 11 2024 Maxwell G <maxwell@gtmx.me> - 0.4.1-3
- Rebuild for golang 1.22.0

* Sat Jan 27 2024 Fedora Release Engineering <releng@fedoraproject.org> - 0.4.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Mon Sep 18 2023 Link Dupont <link@sub-pop.net> - 0.4.1-1
- Update to version 0.4.1 (RHBZ#2239102)

* Wed Aug 09 2023 Yaakov Selkowitz <yselkowi@redhat.com> - 0.3.2-2
- Use vendored dependencies in RHEL builds

* Mon Jul 24 2023 Link Dupont <link@sub-pop.net> - 0.3.2-1
- Update to version 0.3.2 (RHBZ#2225230)

* Sat Jul 22 2023 Fedora Release Engineering <releng@fedoraproject.org> - 0.3.1-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_39_Mass_Rebuild

* Tue Mar 07 2023 Link Dupont <link@sub-pop.net> - 0.3.1-2
- Include D-Bus interface files in devel package

* Sat Jan 21 2023 Fedora Release Engineering <releng@fedoraproject.org> - 0.2.98^1.ffb580f-0.5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_38_Mass_Rebuild

* Sat Jul 23 2022 Fedora Release Engineering <releng@fedoraproject.org> - 0.2.98^1.ffb580f-0.4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_37_Mass_Rebuild

* Tue Jul 19 2022 Maxwell G <gotmax@e.email> - 0.2.98^1.ffb580f-0.3
- Rebuild for CVE-2022-{1705,32148,30631,30633,28131,30635,30632,30630,1962} in
  golang

* Sat Jun 18 2022 Robert-André Mauchin <zebob.m@gmail.com> - 0.2.98^1.ffb580f-0.2
- Rebuilt for CVE-2022-1996, CVE-2022-24675, CVE-2022-28327, CVE-2022-27191,
  CVE-2022-29526, CVE-2022-30629

* Tue Aug 10 2021 Link Dupont <linkdupont@fedoraproject.org> - 0.2.98^1.ffb580f-0.1.20210728gitffb580f
- Initial package

## END: Generated by rpmautospec
